'''
  $Id: helpers.py 192 2021-03-11 15:19:05Z cl_yubikey_2018a $
  
  Copyleft ITEG IT-Engineers GmbH 2022
'''

#import base64
#import configparser
#import glob
import os.path
#import re
#import socket
#import sys
#import zipfile

#from xml.dom.minidom import parse
#import xml.dom.minidom

from clazzes.bomtools import helpers
from clazzes.bomtools import btlogging

log = btlogging.getLogger()


class BTConfiguration:
    '''
      holds eventual parsed configuration and BOM file metadata
    '''

        # static holder for first instance
    staticBTConfiguration = None

    def __init__(self): 
        BTConfiguration.staticBTConfiguration = self
        self.jarFiles = {} # by jar file name
        self.purlLicenseMappings = [] # by order in conf, we want first-match logic sometimes
        self.parsePURLLicenseMappings()
        # runtime globals
        self.reportsDirectory = os.getcwd()
        self.licensesCsvFileName = "licenses.csv"
        self.licensesHtmlFileName = "licenses.html"
        self.osvCsvFileName = "osv-report.csv"
        self.osvHtmlFileName = "osv-report.html"
        self.defaultEcoSystem = "-"
        self.htmlHints = ""
        
    def parsePURLLicenseMappings(self):
        if os.path.exists("/etc/bomtools/purl-license-mappings.conf"):
            log.debug("Parsing /etc/bomtools/purl-license-mappings.conf")
            purlLicenseMappings = helpers.readMappingList("/etc/bomtools/purl-license-mappings.conf")
            for rawMapping in purlLicenseMappings:
                purlLicenseMapping = PURLLicenseMapping(purlPattern=rawMapping[0], licenseInfo=rawMapping[1])
                self.purlLicenseMappings.append(purlLicenseMapping)
            log.debug("Parsed %d PURL license mappings" % len(self.purlLicenseMappings))
        else:
            log.warning("No PURL license to parse: No file /etc/bomtools/purl-license-mappings.conf")


class PURLLicenseMapping:

    def __init__(self, purlPattern:str = "", licenseInfo:str = ""):
        self.purlPattern = purlPattern
        #self.compiledPattern = re.compile(purlPattern)
        self.licenseInfo = licenseInfo

